Index: res/res_features.c
===================================================================
RCS file: /usr/cvsroot/asterisk/res/res_features.c,v
retrieving revision 1.31
diff -u -r1.31 res_features.c
--- res/res_features.c	6 Jan 2005 17:19:54 -0000	1.31
+++ res/res_features.c	7 Jan 2005 01:08:12 -0000
@@ -365,7 +365,11 @@
 
 static int builtin_automonitor(struct ast_channel *chan, struct ast_channel *peer, struct ast_bridge_config *config, char *code, int sense)
 {
-	char *args;
+	char *touch_monitor, *chana = NULL, *chanb = NULL;
+	char buf[128], path[512];
+	int x = 0;
+	
+
 	if (option_verbose > 3)
         ast_verbose(VERBOSE_PREFIX_3 "User hit '%s' to record call.\n", code);
 	if (monitor_ok) {
@@ -375,14 +379,7 @@
 				return -1;
 			}
 		}
-		/* Copy to local variable just in case one of the channels goes away */
-		args = pbx_builtin_getvar_helper(chan, "TOUCH_MONITOR");
-		if (!args)
-			args = pbx_builtin_getvar_helper(peer, "TOUCH_MONITOR");
-		if (!args)
-			args = "WAV||m";
 
-		pbx_exec(peer, monitor_app, args, 1);
 		if (!ast_strlen_zero(courtesytone)) {
 			if (ast_autoservice_start(peer))
 				return -1;
@@ -396,6 +393,37 @@
 			if (ast_autoservice_stop(peer))
 				return -1;
 		}
+		if (peer->monitor) {
+			ast_monitor_stop(peer, 1);
+			return FEATURE_RETURN_SUCCESS;
+		}
+
+		/* Copy to local variable just in case one of the channels goes away */
+		touch_monitor = pbx_builtin_getvar_helper(chan, "TOUCH_MONITOR");
+		if (!touch_monitor)
+			touch_monitor = pbx_builtin_getvar_helper(peer, "TOUCH_MONITOR");
+
+		if(touch_monitor) {
+			snprintf(buf, sizeof(path) - 1, "WAV|auto-%ld-%s|m", time(NULL), touch_monitor);			
+		} else {
+			if(chan->cid.cid_num)
+				chana = ast_strdupa(chan->cid.cid_num);
+			if(peer->cid.cid_num)
+				chanb = ast_strdupa(peer->cid.cid_num);
+
+			if(!chana || ast_strlen_zero(chana))
+				chana = ast_strdupa(chan->name);
+			if(!chanb || ast_strlen_zero(chanb))
+				chanb = ast_strdupa(peer->name);
+			snprintf(buf, sizeof(path) - 1, "WAV|auto-%ld-%s-%s|m", time(NULL), chana, chanb);
+			snprintf(path, sizeof(path) - 1, "/var/spool/asterisk/monitor/%s",buf);
+			for( x = 0; x < strlen(buf); x++)
+				if(buf[x] == '/')
+					buf[x] = '-';
+		}
+
+		pbx_exec(peer, monitor_app, buf, 1);
+
 		return FEATURE_RETURN_SUCCESS;
 	}
 
